Render other components in tab using template in Vue Tab component

25 May 20247 minutes to read

You can render other components inside Tab using Vue template. Through this, we can add content as other components directly with all functionalities to our Tab. Follow the below guidelines for using the other components as template in tab.

  • Declare a template in the template section of the “.vue” file. An empty object “data” needs to be initialized in the data option of the default export object in script section.

  • The template function needs to be assigned to the content property of the EJ2 Vue Tab Component.

<template>
  <div id="app">
    <ejs-tab id="element" ref=element>
      <e-tabitems>
        <e-tabitem :header='headerText0' :content='Template1'></e-tabitem>
        <e-tabitem :header='headerText1' :content='Template2'></e-tabitem>
      </e-tabitems>
    </ejs-tab>
  </div>
</template>
<script setup>

import { TabComponent as EjsTab, TabItemsDirective as ETabitems, TabItemDirective as ETabitem } from '@syncfusion/ej2-vue-navigations';
import { DatePickerComponent, CalendarComponent } from '@syncfusion/ej2-vue-calendars';
import { createApp } from 'vue';

const headerText0 = { text: 'Tab1' };
const headerText1 = { text: 'Tab2' };
const Template1 = () => {
  return {
    template: createApp().component('DatePickerComponent', {
      components: {
        "ejs-datepicker": DatePickerComponent
      },
      template: ' <ejs-datepicker :min="minDate" :max="maxDate" :value="dateVal" ></ejs-datepicker>',
      data() {
        return {
          minDate: new Date("05/09/2017"),
          maxDate: new Date("05/15/2017"),
          dateVal: new Date("05/11/2017")
        };
      }
    })
  }
};
const Template2 = () => {
  return {
    template: createApp().component('DatePickerComponent', {
      components: {
        "ejs-calendar": CalendarComponent
      },
      template: '<ejs-calendar id="calendar" ></ejs-calendar>',
      data() { return {}; }
    })
  }
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>
<template>
  <div id="app">
    <ejs-tab id="element" ref=element>
      <e-tabitems>
        <e-tabitem :header='headerText0' :content='Template1'></e-tabitem>
        <e-tabitem :header='headerText1' :content='Template2'></e-tabitem>
      </e-tabitems>
    </ejs-tab>
  </div>
</template>
<script>

import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-vue-navigations';
import { DatePickerComponent, CalendarComponent } from '@syncfusion/ej2-vue-calendars';
import { createApp } from 'vue';

export default {
  name: "App",
  components: {
    "ejs-tab": TabComponent,
    "e-tabitems": TabItemsDirective,
    "e-tabitem": TabItemDirective
  },
  data: function () {
    return {
      headerText0: { text: 'Tab1' },
      headerText1: { text: 'Tab2' },
      headerText2: { text: 'Tab3' },
      Template1: function () {
        return {
          template: createApp().component('DatePickerComponent', {
            components: {
              "ejs-datepicker": DatePickerComponent
            },
            template: ' <ejs-datepicker :min="minDate" :max="maxDate" :value="dateVal" ></ejs-datepicker>',
            data() {
              return {
                minDate: new Date("05/09/2017"),
                maxDate: new Date("05/15/2017"),
                dateVal: new Date("05/11/2017")
              };
            }
          })
        }
      },
      Template2: function () {
        return {
          template: createApp().component('DatePickerComponent', {
            components: {
              "ejs-calendar": CalendarComponent
            },
            template: '<ejs-calendar id="calendar" ></ejs-calendar>',
            data() { return {}; }
          })
        }
      }
    }
  }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>

Render other components in tab using template in React Tab component

13 Sep 202315 minutes to read

You can render other components inside Tab using React template. Through this, we can add content as other components directly with all functionalities to our Tab. Follow the below guidelines for using the other components as template in tab.

  • Declare a template within the function returns jsx element. If the template does not need arguments no need to pass the properties.

  • Assign the function as value for the template property.

To quickly get started with integrating UI components inside the React Tabs component, you can check out this video:

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { DatePickerComponent, CalendarComponent } from '@syncfusion/ej2-react-calendars';
const App = () => {
    let headertext;
    const buttonTemplate =  () => {
        return (<ButtonComponent>Click me</ButtonComponent>);
    }
    const datePickerTemplate = () => {
        return (<DatePickerComponent></DatePickerComponent>);
    }
    const calendarTemplate = () => {
        return (<CalendarComponent></CalendarComponent>);
    }
    headertext = [{ text: "ButtonComponent" }, { text: "DatePickerComponent" }, { text: "CalendarComponent" }];
    return (<div id='container'>
      <TabComponent heightAdjustMode='Auto' id='tabelement'>
        <TabItemsDirective>
          <TabItemDirective header={headertext[0]} content={buttonTemplate}/>
          <TabItemDirective header={headertext[1]} content={datePickerTemplate}/>
          <TabItemDirective header={headertext[2]} content={calendarTemplate}/>
        </TabItemsDirective>
      </TabComponent>
    </div>);
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { DatePickerComponent, CalendarComponent } from '@syncfusion/ej2-react-calendars';

const App = () => {
  let headertext: any;
  const buttonTemplate = (): JSX.Element => {
    return (<ButtonComponent>Click me</ButtonComponent>);
  }
  const datePickerTemplate = (): JSX.Element => {
    return (<DatePickerComponent></DatePickerComponent>);
  }
  const calenderTemplate = (): JSX.Element => {
    return (<CalendarComponent ></CalendarComponent>);
  }
  headertext = [{ text: "ButtonComponent" }, { text: "DatePickerComponent" }, { text: "CalendarComponent" }];
  return (
    <div id='container'>
      <TabComponent heightAdjustMode='Auto' id='tabelement'>
        <TabItemsDirective>
          <TabItemDirective header={headertext[0]}
            content={buttonTemplate} />
          <TabItemDirective header={headertext[1]}
            content={datePickerTemplate} />
          <TabItemDirective header={headertext[2]}
            content={calenderTemplate} />
        </TabItemsDirective>
      </TabComponent>
    </div>
  );

}

const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tab</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='container'>
        <div id='element'>
            <div id='loader'>Loading</div>
        </div>
    </div>
</body>

</html>

Passing props

The following code example demonstrates how to use props when rendering other components in tab component.

import { useRef, useState } from "react";
import * as React from "react";
import * as ReactDOM from "react-dom";
import { enableRipple } from "@syncfusion/ej2-base";
import {
  TabComponent,
  TabItemDirective,
  TabItemsDirective,
  ContextMenuComponent
} from "@syncfusion/ej2-react-navigations";
import { ButtonComponent } from "@syncfusion/ej2-react-buttons";
import {
  DatePickerComponent,
  CalendarComponent
} from "@syncfusion/ej2-react-calendars";
enableRipple(true);
const App = () => {
  const conTextMenuRef = useRef(null);
  const [menuItems] = useState([{ text: "Cut" }, { text: "Copy" }, { text: "Paste" }]);
  const btnClick = () => {
    conTextMenuRef.current.open(80, 20);
  }
  let headertext;
  const conTextTemplate = () => {
    return (
      <div>
        <ContextMenuComponent
          id="contextmenu"
          ref={conTextMenuRef}
          items={menuItems}
        />
        <ButtonComponent onClick={btnClick}>Click me</ButtonComponent>
      </div>
    );
  }
  const datePickerTemplate = () => {
    return <DatePickerComponent />;
  }
  const calenderTemplate = () => {
    return <CalendarComponent />;
  }
  headertext = [{ text: "ContextMenuComponent" }, { text: "DatePickerComponent" }, { text: "CalendarComponent" }];
  return (
    <div id="container">
      <TabComponent heightAdjustMode="Auto" id="tabelement">
        <TabItemsDirective>
          <TabItemDirective
            header={headertext[0]}
            content={conTextTemplate}
          />
          <TabItemDirective
            header={headertext[1]}
            content={datePickerTemplate}
          />
          <TabItemDirective
            header={headertext[2]}
            content={calenderTemplate}
          />
        </TabItemsDirective>
      </TabComponent>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
import { useRef, useState } from "react";
import * as React from "react";
import * as ReactDOM from "react-dom";
import { enableRipple } from "@syncfusion/ej2-base";
import {
  TabComponent,
  TabItemDirective,
  TabItemsDirective,
  ContextMenuComponent
} from "@syncfusion/ej2-react-navigations";
import { ButtonComponent } from "@syncfusion/ej2-react-buttons";
import {
  DatePickerComponent,
  CalendarComponent
} from "@syncfusion/ej2-react-calendars";
enableRipple(true);
const App = () => {
  const conTextMenuRef = useRef<ContextMenuComponent>(null);
  const [menuItems] = useState([{ text: "Cut" }, { text: "Copy" }, { text: "Paste" }]);
  const btnClick = () => {
    conTextMenuRef.current.open(80, 20);
  }
  let headertext;
  const conTextTemplate = () => {
    return (
      <div>
        <ContextMenuComponent
          id="contextmenu"
          ref={conTextMenuRef}
          items={menuItems}
        />
        <ButtonComponent onClick={btnClick}>Click me</ButtonComponent>
      </div>
    );
  }
  const datePickerTemplate = () => {
    return <DatePickerComponent />;
  }
  const calenderTemplate = () => {
    return <CalendarComponent />;
  }
  headertext = [{ text: "ContextMenuComponent" }, { text: "DatePickerComponent" }, { text: "CalendarComponent" }];
  return (
    <div id="container">
      <TabComponent heightAdjustMode="Auto" id="tabelement">
        <TabItemsDirective>
          <TabItemDirective
            header={headertext[0]}
            content={conTextTemplate}
          />
          <TabItemDirective
            header={headertext[1]}
            content={datePickerTemplate}
          />
          <TabItemDirective
            header={headertext[2]}
            content={calenderTemplate}
          />
        </TabItemsDirective>
      </TabComponent>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tab</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='container'>
        <div id='element'>
            <div id='loader'>Loading</div>
        </div>
    </div>
</body>

</html>